# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetBusinessCaseOperationReportDownloadUrlResult',
    'AwaitableGetBusinessCaseOperationReportDownloadUrlResult',
    'get_business_case_operation_report_download_url',
    'get_business_case_operation_report_download_url_output',
]

@pulumi.output_type
class GetBusinessCaseOperationReportDownloadUrlResult:
    """
    Download URL for assessment report.
    """
    def __init__(__self__, business_case_report_url=None, expiration_time=None):
        if business_case_report_url and not isinstance(business_case_report_url, str):
            raise TypeError("Expected argument 'business_case_report_url' to be a str")
        pulumi.set(__self__, "business_case_report_url", business_case_report_url)
        if expiration_time and not isinstance(expiration_time, str):
            raise TypeError("Expected argument 'expiration_time' to be a str")
        pulumi.set(__self__, "expiration_time", expiration_time)

    @property
    @pulumi.getter(name="businessCaseReportUrl")
    def business_case_report_url(self) -> str:
        """
        Hyperlink to download report.
        """
        return pulumi.get(self, "business_case_report_url")

    @property
    @pulumi.getter(name="expirationTime")
    def expiration_time(self) -> str:
        """
        Expiry date of download url.
        """
        return pulumi.get(self, "expiration_time")


class AwaitableGetBusinessCaseOperationReportDownloadUrlResult(GetBusinessCaseOperationReportDownloadUrlResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBusinessCaseOperationReportDownloadUrlResult(
            business_case_report_url=self.business_case_report_url,
            expiration_time=self.expiration_time)


def get_business_case_operation_report_download_url(business_case_name: Optional[str] = None,
                                                    project_name: Optional[str] = None,
                                                    resource_group_name: Optional[str] = None,
                                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBusinessCaseOperationReportDownloadUrlResult:
    """
    Get the URL for downloading the business case in a report format.
    Azure REST API version: 2023-04-01-preview.


    :param str business_case_name: Business case ARM name
    :param str project_name: Assessment Project Name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['businessCaseName'] = business_case_name
    __args__['projectName'] = project_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:migrate:getBusinessCaseOperationReportDownloadUrl', __args__, opts=opts, typ=GetBusinessCaseOperationReportDownloadUrlResult).value

    return AwaitableGetBusinessCaseOperationReportDownloadUrlResult(
        business_case_report_url=pulumi.get(__ret__, 'business_case_report_url'),
        expiration_time=pulumi.get(__ret__, 'expiration_time'))


@_utilities.lift_output_func(get_business_case_operation_report_download_url)
def get_business_case_operation_report_download_url_output(business_case_name: Optional[pulumi.Input[str]] = None,
                                                           project_name: Optional[pulumi.Input[str]] = None,
                                                           resource_group_name: Optional[pulumi.Input[str]] = None,
                                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBusinessCaseOperationReportDownloadUrlResult]:
    """
    Get the URL for downloading the business case in a report format.
    Azure REST API version: 2023-04-01-preview.


    :param str business_case_name: Business case ARM name
    :param str project_name: Assessment Project Name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    ...
