# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['WebAppAssessmentV2OperationArgs', 'WebAppAssessmentV2Operation']

@pulumi.input_type
class WebAppAssessmentV2OperationArgs:
    def __init__(__self__, *,
                 group_name: pulumi.Input[str],
                 project_name: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 app_svc_container_settings: Optional[pulumi.Input['AppSvcContainerSettingsArgs']] = None,
                 app_svc_native_settings: Optional[pulumi.Input['AppSvcNativeSettingsArgs']] = None,
                 assessment_name: Optional[pulumi.Input[str]] = None,
                 assessment_type: Optional[pulumi.Input[Union[str, 'AssessmentType']]] = None,
                 azure_location: Optional[pulumi.Input[str]] = None,
                 azure_offer_code: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]] = None,
                 azure_security_offering_type: Optional[pulumi.Input[Union[str, 'AzureSecurityOfferingType']]] = None,
                 confidence_rating_in_percentage: Optional[pulumi.Input[float]] = None,
                 currency: Optional[pulumi.Input[Union[str, 'AzureCurrency']]] = None,
                 discount_percentage: Optional[pulumi.Input[float]] = None,
                 discovered_entity_light_summary: Optional[pulumi.Input['DiscoveredEntityLightSummaryArgs']] = None,
                 ea_subscription_id: Optional[pulumi.Input[str]] = None,
                 entity_uptime: Optional[pulumi.Input['EntityUptimeArgs']] = None,
                 environment_type: Optional[pulumi.Input[Union[str, 'EnvironmentType']]] = None,
                 group_type: Optional[pulumi.Input[Union[str, 'GroupType']]] = None,
                 percentile: Optional[pulumi.Input[Union[str, 'Percentile']]] = None,
                 perf_data_end_time: Optional[pulumi.Input[str]] = None,
                 perf_data_start_time: Optional[pulumi.Input[str]] = None,
                 reserved_instance: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]] = None,
                 scaling_factor: Optional[pulumi.Input[float]] = None,
                 sizing_criterion: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]] = None,
                 time_range: Optional[pulumi.Input[Union[str, 'TimeRange']]] = None):
        """
        The set of arguments for constructing a WebAppAssessmentV2Operation resource.
        :param pulumi.Input[str] group_name: Group ARM name
        :param pulumi.Input[str] project_name: Assessment Project Name
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input['AppSvcContainerSettingsArgs'] app_svc_container_settings: Gets or sets user configurable app service container database settings.
        :param pulumi.Input['AppSvcNativeSettingsArgs'] app_svc_native_settings: Gets or sets user configurable app service native settings.
        :param pulumi.Input[str] assessment_name: Web app Assessment arm name.
        :param pulumi.Input[Union[str, 'AssessmentType']] assessment_type: Assessment type of the assessment.
        :param pulumi.Input[str] azure_location: Azure Location or Azure region where to which the machines will be migrated.
        :param pulumi.Input[Union[str, 'AzureOfferCode']] azure_offer_code: Azure Offer Code.
        :param pulumi.Input[Union[str, 'AzureSecurityOfferingType']] azure_security_offering_type: Gets or sets a value indicating azure security offering type.
        :param pulumi.Input[float] confidence_rating_in_percentage: Confidence Rating in Percentage.
        :param pulumi.Input[Union[str, 'AzureCurrency']] currency: Currency in which prices should be reported.
        :param pulumi.Input[float] discount_percentage: Custom discount percentage.
        :param pulumi.Input['DiscoveredEntityLightSummaryArgs'] discovered_entity_light_summary: Gets or sets user configurable discovered entity settings.
        :param pulumi.Input[str] ea_subscription_id: Gets or sets the Enterprise agreement subscription id.
        :param pulumi.Input['EntityUptimeArgs'] entity_uptime: Gets or sets the duration for which the entity (Web app, VMs) are up in the
               on-premises environment.
        :param pulumi.Input[Union[str, 'EnvironmentType']] environment_type: Gets or sets user configurable setting to display the environment type.
        :param pulumi.Input[Union[str, 'GroupType']] group_type: Gets the group type for the assessment.
        :param pulumi.Input[Union[str, 'Percentile']] percentile: Percentile of the utilization data values to be considered while assessing
               machines.
        :param pulumi.Input[str] perf_data_end_time: Gets or sets the end time to consider performance data for assessment.
        :param pulumi.Input[str] perf_data_start_time: Gets or sets the start time to consider performance data for assessment.
        :param pulumi.Input[Union[str, 'AzureReservedInstance']] reserved_instance: Reserved instance.
        :param pulumi.Input[float] scaling_factor: Percentage of buffer that user wants on performance metrics when recommending
               Azure sizes.
        :param pulumi.Input[Union[str, 'AssessmentSizingCriterion']] sizing_criterion: Assessment sizing criterion.
        :param pulumi.Input[Union[str, 'TimeRange']] time_range: Time Range for which the historic utilization data should be considered for
               assessment.
        """
        pulumi.set(__self__, "group_name", group_name)
        pulumi.set(__self__, "project_name", project_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if app_svc_container_settings is not None:
            pulumi.set(__self__, "app_svc_container_settings", app_svc_container_settings)
        if app_svc_native_settings is not None:
            pulumi.set(__self__, "app_svc_native_settings", app_svc_native_settings)
        if assessment_name is not None:
            pulumi.set(__self__, "assessment_name", assessment_name)
        if assessment_type is not None:
            pulumi.set(__self__, "assessment_type", assessment_type)
        if azure_location is not None:
            pulumi.set(__self__, "azure_location", azure_location)
        if azure_offer_code is not None:
            pulumi.set(__self__, "azure_offer_code", azure_offer_code)
        if azure_security_offering_type is not None:
            pulumi.set(__self__, "azure_security_offering_type", azure_security_offering_type)
        if confidence_rating_in_percentage is not None:
            pulumi.set(__self__, "confidence_rating_in_percentage", confidence_rating_in_percentage)
        if currency is not None:
            pulumi.set(__self__, "currency", currency)
        if discount_percentage is not None:
            pulumi.set(__self__, "discount_percentage", discount_percentage)
        if discovered_entity_light_summary is not None:
            pulumi.set(__self__, "discovered_entity_light_summary", discovered_entity_light_summary)
        if ea_subscription_id is not None:
            pulumi.set(__self__, "ea_subscription_id", ea_subscription_id)
        if entity_uptime is not None:
            pulumi.set(__self__, "entity_uptime", entity_uptime)
        if environment_type is not None:
            pulumi.set(__self__, "environment_type", environment_type)
        if group_type is not None:
            pulumi.set(__self__, "group_type", group_type)
        if percentile is not None:
            pulumi.set(__self__, "percentile", percentile)
        if perf_data_end_time is not None:
            pulumi.set(__self__, "perf_data_end_time", perf_data_end_time)
        if perf_data_start_time is not None:
            pulumi.set(__self__, "perf_data_start_time", perf_data_start_time)
        if reserved_instance is not None:
            pulumi.set(__self__, "reserved_instance", reserved_instance)
        if scaling_factor is not None:
            pulumi.set(__self__, "scaling_factor", scaling_factor)
        if sizing_criterion is not None:
            pulumi.set(__self__, "sizing_criterion", sizing_criterion)
        if time_range is not None:
            pulumi.set(__self__, "time_range", time_range)

    @property
    @pulumi.getter(name="groupName")
    def group_name(self) -> pulumi.Input[str]:
        """
        Group ARM name
        """
        return pulumi.get(self, "group_name")

    @group_name.setter
    def group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_name", value)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> pulumi.Input[str]:
        """
        Assessment Project Name
        """
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "project_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="appSvcContainerSettings")
    def app_svc_container_settings(self) -> Optional[pulumi.Input['AppSvcContainerSettingsArgs']]:
        """
        Gets or sets user configurable app service container database settings.
        """
        return pulumi.get(self, "app_svc_container_settings")

    @app_svc_container_settings.setter
    def app_svc_container_settings(self, value: Optional[pulumi.Input['AppSvcContainerSettingsArgs']]):
        pulumi.set(self, "app_svc_container_settings", value)

    @property
    @pulumi.getter(name="appSvcNativeSettings")
    def app_svc_native_settings(self) -> Optional[pulumi.Input['AppSvcNativeSettingsArgs']]:
        """
        Gets or sets user configurable app service native settings.
        """
        return pulumi.get(self, "app_svc_native_settings")

    @app_svc_native_settings.setter
    def app_svc_native_settings(self, value: Optional[pulumi.Input['AppSvcNativeSettingsArgs']]):
        pulumi.set(self, "app_svc_native_settings", value)

    @property
    @pulumi.getter(name="assessmentName")
    def assessment_name(self) -> Optional[pulumi.Input[str]]:
        """
        Web app Assessment arm name.
        """
        return pulumi.get(self, "assessment_name")

    @assessment_name.setter
    def assessment_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "assessment_name", value)

    @property
    @pulumi.getter(name="assessmentType")
    def assessment_type(self) -> Optional[pulumi.Input[Union[str, 'AssessmentType']]]:
        """
        Assessment type of the assessment.
        """
        return pulumi.get(self, "assessment_type")

    @assessment_type.setter
    def assessment_type(self, value: Optional[pulumi.Input[Union[str, 'AssessmentType']]]):
        pulumi.set(self, "assessment_type", value)

    @property
    @pulumi.getter(name="azureLocation")
    def azure_location(self) -> Optional[pulumi.Input[str]]:
        """
        Azure Location or Azure region where to which the machines will be migrated.
        """
        return pulumi.get(self, "azure_location")

    @azure_location.setter
    def azure_location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "azure_location", value)

    @property
    @pulumi.getter(name="azureOfferCode")
    def azure_offer_code(self) -> Optional[pulumi.Input[Union[str, 'AzureOfferCode']]]:
        """
        Azure Offer Code.
        """
        return pulumi.get(self, "azure_offer_code")

    @azure_offer_code.setter
    def azure_offer_code(self, value: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]]):
        pulumi.set(self, "azure_offer_code", value)

    @property
    @pulumi.getter(name="azureSecurityOfferingType")
    def azure_security_offering_type(self) -> Optional[pulumi.Input[Union[str, 'AzureSecurityOfferingType']]]:
        """
        Gets or sets a value indicating azure security offering type.
        """
        return pulumi.get(self, "azure_security_offering_type")

    @azure_security_offering_type.setter
    def azure_security_offering_type(self, value: Optional[pulumi.Input[Union[str, 'AzureSecurityOfferingType']]]):
        pulumi.set(self, "azure_security_offering_type", value)

    @property
    @pulumi.getter(name="confidenceRatingInPercentage")
    def confidence_rating_in_percentage(self) -> Optional[pulumi.Input[float]]:
        """
        Confidence Rating in Percentage.
        """
        return pulumi.get(self, "confidence_rating_in_percentage")

    @confidence_rating_in_percentage.setter
    def confidence_rating_in_percentage(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "confidence_rating_in_percentage", value)

    @property
    @pulumi.getter
    def currency(self) -> Optional[pulumi.Input[Union[str, 'AzureCurrency']]]:
        """
        Currency in which prices should be reported.
        """
        return pulumi.get(self, "currency")

    @currency.setter
    def currency(self, value: Optional[pulumi.Input[Union[str, 'AzureCurrency']]]):
        pulumi.set(self, "currency", value)

    @property
    @pulumi.getter(name="discountPercentage")
    def discount_percentage(self) -> Optional[pulumi.Input[float]]:
        """
        Custom discount percentage.
        """
        return pulumi.get(self, "discount_percentage")

    @discount_percentage.setter
    def discount_percentage(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "discount_percentage", value)

    @property
    @pulumi.getter(name="discoveredEntityLightSummary")
    def discovered_entity_light_summary(self) -> Optional[pulumi.Input['DiscoveredEntityLightSummaryArgs']]:
        """
        Gets or sets user configurable discovered entity settings.
        """
        return pulumi.get(self, "discovered_entity_light_summary")

    @discovered_entity_light_summary.setter
    def discovered_entity_light_summary(self, value: Optional[pulumi.Input['DiscoveredEntityLightSummaryArgs']]):
        pulumi.set(self, "discovered_entity_light_summary", value)

    @property
    @pulumi.getter(name="eaSubscriptionId")
    def ea_subscription_id(self) -> Optional[pulumi.Input[str]]:
        """
        Gets or sets the Enterprise agreement subscription id.
        """
        return pulumi.get(self, "ea_subscription_id")

    @ea_subscription_id.setter
    def ea_subscription_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ea_subscription_id", value)

    @property
    @pulumi.getter(name="entityUptime")
    def entity_uptime(self) -> Optional[pulumi.Input['EntityUptimeArgs']]:
        """
        Gets or sets the duration for which the entity (Web app, VMs) are up in the
        on-premises environment.
        """
        return pulumi.get(self, "entity_uptime")

    @entity_uptime.setter
    def entity_uptime(self, value: Optional[pulumi.Input['EntityUptimeArgs']]):
        pulumi.set(self, "entity_uptime", value)

    @property
    @pulumi.getter(name="environmentType")
    def environment_type(self) -> Optional[pulumi.Input[Union[str, 'EnvironmentType']]]:
        """
        Gets or sets user configurable setting to display the environment type.
        """
        return pulumi.get(self, "environment_type")

    @environment_type.setter
    def environment_type(self, value: Optional[pulumi.Input[Union[str, 'EnvironmentType']]]):
        pulumi.set(self, "environment_type", value)

    @property
    @pulumi.getter(name="groupType")
    def group_type(self) -> Optional[pulumi.Input[Union[str, 'GroupType']]]:
        """
        Gets the group type for the assessment.
        """
        return pulumi.get(self, "group_type")

    @group_type.setter
    def group_type(self, value: Optional[pulumi.Input[Union[str, 'GroupType']]]):
        pulumi.set(self, "group_type", value)

    @property
    @pulumi.getter
    def percentile(self) -> Optional[pulumi.Input[Union[str, 'Percentile']]]:
        """
        Percentile of the utilization data values to be considered while assessing
        machines.
        """
        return pulumi.get(self, "percentile")

    @percentile.setter
    def percentile(self, value: Optional[pulumi.Input[Union[str, 'Percentile']]]):
        pulumi.set(self, "percentile", value)

    @property
    @pulumi.getter(name="perfDataEndTime")
    def perf_data_end_time(self) -> Optional[pulumi.Input[str]]:
        """
        Gets or sets the end time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_end_time")

    @perf_data_end_time.setter
    def perf_data_end_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "perf_data_end_time", value)

    @property
    @pulumi.getter(name="perfDataStartTime")
    def perf_data_start_time(self) -> Optional[pulumi.Input[str]]:
        """
        Gets or sets the start time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_start_time")

    @perf_data_start_time.setter
    def perf_data_start_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "perf_data_start_time", value)

    @property
    @pulumi.getter(name="reservedInstance")
    def reserved_instance(self) -> Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]]:
        """
        Reserved instance.
        """
        return pulumi.get(self, "reserved_instance")

    @reserved_instance.setter
    def reserved_instance(self, value: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]]):
        pulumi.set(self, "reserved_instance", value)

    @property
    @pulumi.getter(name="scalingFactor")
    def scaling_factor(self) -> Optional[pulumi.Input[float]]:
        """
        Percentage of buffer that user wants on performance metrics when recommending
        Azure sizes.
        """
        return pulumi.get(self, "scaling_factor")

    @scaling_factor.setter
    def scaling_factor(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "scaling_factor", value)

    @property
    @pulumi.getter(name="sizingCriterion")
    def sizing_criterion(self) -> Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]]:
        """
        Assessment sizing criterion.
        """
        return pulumi.get(self, "sizing_criterion")

    @sizing_criterion.setter
    def sizing_criterion(self, value: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]]):
        pulumi.set(self, "sizing_criterion", value)

    @property
    @pulumi.getter(name="timeRange")
    def time_range(self) -> Optional[pulumi.Input[Union[str, 'TimeRange']]]:
        """
        Time Range for which the historic utilization data should be considered for
        assessment.
        """
        return pulumi.get(self, "time_range")

    @time_range.setter
    def time_range(self, value: Optional[pulumi.Input[Union[str, 'TimeRange']]]):
        pulumi.set(self, "time_range", value)


class WebAppAssessmentV2Operation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_svc_container_settings: Optional[pulumi.Input[Union['AppSvcContainerSettingsArgs', 'AppSvcContainerSettingsArgsDict']]] = None,
                 app_svc_native_settings: Optional[pulumi.Input[Union['AppSvcNativeSettingsArgs', 'AppSvcNativeSettingsArgsDict']]] = None,
                 assessment_name: Optional[pulumi.Input[str]] = None,
                 assessment_type: Optional[pulumi.Input[Union[str, 'AssessmentType']]] = None,
                 azure_location: Optional[pulumi.Input[str]] = None,
                 azure_offer_code: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]] = None,
                 azure_security_offering_type: Optional[pulumi.Input[Union[str, 'AzureSecurityOfferingType']]] = None,
                 confidence_rating_in_percentage: Optional[pulumi.Input[float]] = None,
                 currency: Optional[pulumi.Input[Union[str, 'AzureCurrency']]] = None,
                 discount_percentage: Optional[pulumi.Input[float]] = None,
                 discovered_entity_light_summary: Optional[pulumi.Input[Union['DiscoveredEntityLightSummaryArgs', 'DiscoveredEntityLightSummaryArgsDict']]] = None,
                 ea_subscription_id: Optional[pulumi.Input[str]] = None,
                 entity_uptime: Optional[pulumi.Input[Union['EntityUptimeArgs', 'EntityUptimeArgsDict']]] = None,
                 environment_type: Optional[pulumi.Input[Union[str, 'EnvironmentType']]] = None,
                 group_name: Optional[pulumi.Input[str]] = None,
                 group_type: Optional[pulumi.Input[Union[str, 'GroupType']]] = None,
                 percentile: Optional[pulumi.Input[Union[str, 'Percentile']]] = None,
                 perf_data_end_time: Optional[pulumi.Input[str]] = None,
                 perf_data_start_time: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 reserved_instance: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 scaling_factor: Optional[pulumi.Input[float]] = None,
                 sizing_criterion: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]] = None,
                 time_range: Optional[pulumi.Input[Union[str, 'TimeRange']]] = None,
                 __props__=None):
        """
        Web app Assessment REST resource.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['AppSvcContainerSettingsArgs', 'AppSvcContainerSettingsArgsDict']] app_svc_container_settings: Gets or sets user configurable app service container database settings.
        :param pulumi.Input[Union['AppSvcNativeSettingsArgs', 'AppSvcNativeSettingsArgsDict']] app_svc_native_settings: Gets or sets user configurable app service native settings.
        :param pulumi.Input[str] assessment_name: Web app Assessment arm name.
        :param pulumi.Input[Union[str, 'AssessmentType']] assessment_type: Assessment type of the assessment.
        :param pulumi.Input[str] azure_location: Azure Location or Azure region where to which the machines will be migrated.
        :param pulumi.Input[Union[str, 'AzureOfferCode']] azure_offer_code: Azure Offer Code.
        :param pulumi.Input[Union[str, 'AzureSecurityOfferingType']] azure_security_offering_type: Gets or sets a value indicating azure security offering type.
        :param pulumi.Input[float] confidence_rating_in_percentage: Confidence Rating in Percentage.
        :param pulumi.Input[Union[str, 'AzureCurrency']] currency: Currency in which prices should be reported.
        :param pulumi.Input[float] discount_percentage: Custom discount percentage.
        :param pulumi.Input[Union['DiscoveredEntityLightSummaryArgs', 'DiscoveredEntityLightSummaryArgsDict']] discovered_entity_light_summary: Gets or sets user configurable discovered entity settings.
        :param pulumi.Input[str] ea_subscription_id: Gets or sets the Enterprise agreement subscription id.
        :param pulumi.Input[Union['EntityUptimeArgs', 'EntityUptimeArgsDict']] entity_uptime: Gets or sets the duration for which the entity (Web app, VMs) are up in the
               on-premises environment.
        :param pulumi.Input[Union[str, 'EnvironmentType']] environment_type: Gets or sets user configurable setting to display the environment type.
        :param pulumi.Input[str] group_name: Group ARM name
        :param pulumi.Input[Union[str, 'GroupType']] group_type: Gets the group type for the assessment.
        :param pulumi.Input[Union[str, 'Percentile']] percentile: Percentile of the utilization data values to be considered while assessing
               machines.
        :param pulumi.Input[str] perf_data_end_time: Gets or sets the end time to consider performance data for assessment.
        :param pulumi.Input[str] perf_data_start_time: Gets or sets the start time to consider performance data for assessment.
        :param pulumi.Input[str] project_name: Assessment Project Name
        :param pulumi.Input[Union[str, 'AzureReservedInstance']] reserved_instance: Reserved instance.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[float] scaling_factor: Percentage of buffer that user wants on performance metrics when recommending
               Azure sizes.
        :param pulumi.Input[Union[str, 'AssessmentSizingCriterion']] sizing_criterion: Assessment sizing criterion.
        :param pulumi.Input[Union[str, 'TimeRange']] time_range: Time Range for which the historic utilization data should be considered for
               assessment.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WebAppAssessmentV2OperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Web app Assessment REST resource.

        :param str resource_name: The name of the resource.
        :param WebAppAssessmentV2OperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WebAppAssessmentV2OperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_svc_container_settings: Optional[pulumi.Input[Union['AppSvcContainerSettingsArgs', 'AppSvcContainerSettingsArgsDict']]] = None,
                 app_svc_native_settings: Optional[pulumi.Input[Union['AppSvcNativeSettingsArgs', 'AppSvcNativeSettingsArgsDict']]] = None,
                 assessment_name: Optional[pulumi.Input[str]] = None,
                 assessment_type: Optional[pulumi.Input[Union[str, 'AssessmentType']]] = None,
                 azure_location: Optional[pulumi.Input[str]] = None,
                 azure_offer_code: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]] = None,
                 azure_security_offering_type: Optional[pulumi.Input[Union[str, 'AzureSecurityOfferingType']]] = None,
                 confidence_rating_in_percentage: Optional[pulumi.Input[float]] = None,
                 currency: Optional[pulumi.Input[Union[str, 'AzureCurrency']]] = None,
                 discount_percentage: Optional[pulumi.Input[float]] = None,
                 discovered_entity_light_summary: Optional[pulumi.Input[Union['DiscoveredEntityLightSummaryArgs', 'DiscoveredEntityLightSummaryArgsDict']]] = None,
                 ea_subscription_id: Optional[pulumi.Input[str]] = None,
                 entity_uptime: Optional[pulumi.Input[Union['EntityUptimeArgs', 'EntityUptimeArgsDict']]] = None,
                 environment_type: Optional[pulumi.Input[Union[str, 'EnvironmentType']]] = None,
                 group_name: Optional[pulumi.Input[str]] = None,
                 group_type: Optional[pulumi.Input[Union[str, 'GroupType']]] = None,
                 percentile: Optional[pulumi.Input[Union[str, 'Percentile']]] = None,
                 perf_data_end_time: Optional[pulumi.Input[str]] = None,
                 perf_data_start_time: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 reserved_instance: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 scaling_factor: Optional[pulumi.Input[float]] = None,
                 sizing_criterion: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]] = None,
                 time_range: Optional[pulumi.Input[Union[str, 'TimeRange']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WebAppAssessmentV2OperationArgs.__new__(WebAppAssessmentV2OperationArgs)

            __props__.__dict__["app_svc_container_settings"] = app_svc_container_settings
            __props__.__dict__["app_svc_native_settings"] = app_svc_native_settings
            __props__.__dict__["assessment_name"] = assessment_name
            __props__.__dict__["assessment_type"] = assessment_type
            __props__.__dict__["azure_location"] = azure_location
            __props__.__dict__["azure_offer_code"] = azure_offer_code
            __props__.__dict__["azure_security_offering_type"] = azure_security_offering_type
            __props__.__dict__["confidence_rating_in_percentage"] = confidence_rating_in_percentage
            __props__.__dict__["currency"] = currency
            __props__.__dict__["discount_percentage"] = discount_percentage
            __props__.__dict__["discovered_entity_light_summary"] = discovered_entity_light_summary
            __props__.__dict__["ea_subscription_id"] = ea_subscription_id
            __props__.__dict__["entity_uptime"] = entity_uptime
            __props__.__dict__["environment_type"] = environment_type
            if group_name is None and not opts.urn:
                raise TypeError("Missing required property 'group_name'")
            __props__.__dict__["group_name"] = group_name
            __props__.__dict__["group_type"] = group_type
            __props__.__dict__["percentile"] = percentile
            __props__.__dict__["perf_data_end_time"] = perf_data_end_time
            __props__.__dict__["perf_data_start_time"] = perf_data_start_time
            if project_name is None and not opts.urn:
                raise TypeError("Missing required property 'project_name'")
            __props__.__dict__["project_name"] = project_name
            __props__.__dict__["reserved_instance"] = reserved_instance
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["scaling_factor"] = scaling_factor
            __props__.__dict__["sizing_criterion"] = sizing_criterion
            __props__.__dict__["time_range"] = time_range
            __props__.__dict__["created_timestamp"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["prices_timestamp"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["schema_version"] = None
            __props__.__dict__["stage"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
            __props__.__dict__["updated_timestamp"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:migrate:WebAppAssessmentV2Operation")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(WebAppAssessmentV2Operation, __self__).__init__(
            'azure-native:migrate/v20230401preview:WebAppAssessmentV2Operation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'WebAppAssessmentV2Operation':
        """
        Get an existing WebAppAssessmentV2Operation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = WebAppAssessmentV2OperationArgs.__new__(WebAppAssessmentV2OperationArgs)

        __props__.__dict__["app_svc_container_settings"] = None
        __props__.__dict__["app_svc_native_settings"] = None
        __props__.__dict__["assessment_type"] = None
        __props__.__dict__["azure_location"] = None
        __props__.__dict__["azure_offer_code"] = None
        __props__.__dict__["azure_security_offering_type"] = None
        __props__.__dict__["confidence_rating_in_percentage"] = None
        __props__.__dict__["created_timestamp"] = None
        __props__.__dict__["currency"] = None
        __props__.__dict__["discount_percentage"] = None
        __props__.__dict__["discovered_entity_light_summary"] = None
        __props__.__dict__["ea_subscription_id"] = None
        __props__.__dict__["entity_uptime"] = None
        __props__.__dict__["environment_type"] = None
        __props__.__dict__["group_type"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["percentile"] = None
        __props__.__dict__["perf_data_end_time"] = None
        __props__.__dict__["perf_data_start_time"] = None
        __props__.__dict__["prices_timestamp"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["reserved_instance"] = None
        __props__.__dict__["scaling_factor"] = None
        __props__.__dict__["schema_version"] = None
        __props__.__dict__["sizing_criterion"] = None
        __props__.__dict__["stage"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["time_range"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["updated_timestamp"] = None
        return WebAppAssessmentV2Operation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="appSvcContainerSettings")
    def app_svc_container_settings(self) -> pulumi.Output[Optional['outputs.AppSvcContainerSettingsResponse']]:
        """
        Gets or sets user configurable app service container database settings.
        """
        return pulumi.get(self, "app_svc_container_settings")

    @property
    @pulumi.getter(name="appSvcNativeSettings")
    def app_svc_native_settings(self) -> pulumi.Output[Optional['outputs.AppSvcNativeSettingsResponse']]:
        """
        Gets or sets user configurable app service native settings.
        """
        return pulumi.get(self, "app_svc_native_settings")

    @property
    @pulumi.getter(name="assessmentType")
    def assessment_type(self) -> pulumi.Output[Optional[str]]:
        """
        Assessment type of the assessment.
        """
        return pulumi.get(self, "assessment_type")

    @property
    @pulumi.getter(name="azureLocation")
    def azure_location(self) -> pulumi.Output[Optional[str]]:
        """
        Azure Location or Azure region where to which the machines will be migrated.
        """
        return pulumi.get(self, "azure_location")

    @property
    @pulumi.getter(name="azureOfferCode")
    def azure_offer_code(self) -> pulumi.Output[Optional[str]]:
        """
        Azure Offer Code.
        """
        return pulumi.get(self, "azure_offer_code")

    @property
    @pulumi.getter(name="azureSecurityOfferingType")
    def azure_security_offering_type(self) -> pulumi.Output[Optional[str]]:
        """
        Gets or sets a value indicating azure security offering type.
        """
        return pulumi.get(self, "azure_security_offering_type")

    @property
    @pulumi.getter(name="confidenceRatingInPercentage")
    def confidence_rating_in_percentage(self) -> pulumi.Output[Optional[float]]:
        """
        Confidence Rating in Percentage.
        """
        return pulumi.get(self, "confidence_rating_in_percentage")

    @property
    @pulumi.getter(name="createdTimestamp")
    def created_timestamp(self) -> pulumi.Output[str]:
        """
        Date and Time when assessment was created.
        """
        return pulumi.get(self, "created_timestamp")

    @property
    @pulumi.getter
    def currency(self) -> pulumi.Output[Optional[str]]:
        """
        Currency in which prices should be reported.
        """
        return pulumi.get(self, "currency")

    @property
    @pulumi.getter(name="discountPercentage")
    def discount_percentage(self) -> pulumi.Output[Optional[float]]:
        """
        Custom discount percentage.
        """
        return pulumi.get(self, "discount_percentage")

    @property
    @pulumi.getter(name="discoveredEntityLightSummary")
    def discovered_entity_light_summary(self) -> pulumi.Output[Optional['outputs.DiscoveredEntityLightSummaryResponse']]:
        """
        Gets or sets user configurable discovered entity settings.
        """
        return pulumi.get(self, "discovered_entity_light_summary")

    @property
    @pulumi.getter(name="eaSubscriptionId")
    def ea_subscription_id(self) -> pulumi.Output[Optional[str]]:
        """
        Gets or sets the Enterprise agreement subscription id.
        """
        return pulumi.get(self, "ea_subscription_id")

    @property
    @pulumi.getter(name="entityUptime")
    def entity_uptime(self) -> pulumi.Output[Optional['outputs.EntityUptimeResponse']]:
        """
        Gets or sets the duration for which the entity (Web app, VMs) are up in the
        on-premises environment.
        """
        return pulumi.get(self, "entity_uptime")

    @property
    @pulumi.getter(name="environmentType")
    def environment_type(self) -> pulumi.Output[Optional[str]]:
        """
        Gets or sets user configurable setting to display the environment type.
        """
        return pulumi.get(self, "environment_type")

    @property
    @pulumi.getter(name="groupType")
    def group_type(self) -> pulumi.Output[Optional[str]]:
        """
        Gets the group type for the assessment.
        """
        return pulumi.get(self, "group_type")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def percentile(self) -> pulumi.Output[Optional[str]]:
        """
        Percentile of the utilization data values to be considered while assessing
        machines.
        """
        return pulumi.get(self, "percentile")

    @property
    @pulumi.getter(name="perfDataEndTime")
    def perf_data_end_time(self) -> pulumi.Output[Optional[str]]:
        """
        Gets or sets the end time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_end_time")

    @property
    @pulumi.getter(name="perfDataStartTime")
    def perf_data_start_time(self) -> pulumi.Output[Optional[str]]:
        """
        Gets or sets the start time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_start_time")

    @property
    @pulumi.getter(name="pricesTimestamp")
    def prices_timestamp(self) -> pulumi.Output[str]:
        """
        Last time when rates were queried.
        """
        return pulumi.get(self, "prices_timestamp")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="reservedInstance")
    def reserved_instance(self) -> pulumi.Output[Optional[str]]:
        """
        Reserved instance.
        """
        return pulumi.get(self, "reserved_instance")

    @property
    @pulumi.getter(name="scalingFactor")
    def scaling_factor(self) -> pulumi.Output[Optional[float]]:
        """
        Percentage of buffer that user wants on performance metrics when recommending
        Azure sizes.
        """
        return pulumi.get(self, "scaling_factor")

    @property
    @pulumi.getter(name="schemaVersion")
    def schema_version(self) -> pulumi.Output[str]:
        """
        Schema version.
        """
        return pulumi.get(self, "schema_version")

    @property
    @pulumi.getter(name="sizingCriterion")
    def sizing_criterion(self) -> pulumi.Output[Optional[str]]:
        """
        Assessment sizing criterion.
        """
        return pulumi.get(self, "sizing_criterion")

    @property
    @pulumi.getter
    def stage(self) -> pulumi.Output[str]:
        """
        User configurable setting to display the Stage of Assessment.
        """
        return pulumi.get(self, "stage")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Whether assessment is in valid state and all machines have been assessed.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="timeRange")
    def time_range(self) -> pulumi.Output[Optional[str]]:
        """
        Time Range for which the historic utilization data should be considered for
        assessment.
        """
        return pulumi.get(self, "time_range")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedTimestamp")
    def updated_timestamp(self) -> pulumi.Output[str]:
        """
        Date and Time when assessment was last updated.
        """
        return pulumi.get(self, "updated_timestamp")

