# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from . import outputs

__all__ = [
    'GetDefenderForStorageResult',
    'AwaitableGetDefenderForStorageResult',
    'get_defender_for_storage',
    'get_defender_for_storage_output',
]

@pulumi.output_type
class GetDefenderForStorageResult:
    """
    The Defender for Storage resource.
    """
    def __init__(__self__, id=None, name=None, properties=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Resource Id
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Resource name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.DefenderForStorageSettingPropertiesResponse':
        """
        Defender for Storage resource properties.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Resource type
        """
        return pulumi.get(self, "type")


class AwaitableGetDefenderForStorageResult(GetDefenderForStorageResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDefenderForStorageResult(
            id=self.id,
            name=self.name,
            properties=self.properties,
            type=self.type)


def get_defender_for_storage(resource_id: Optional[str] = None,
                             setting_name: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDefenderForStorageResult:
    """
    Gets the Defender for Storage settings for the specified storage account.


    :param str resource_id: The identifier of the resource.
    :param str setting_name: Defender for Storage setting name.
    """
    __args__ = dict()
    __args__['resourceId'] = resource_id
    __args__['settingName'] = setting_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:security/v20221201preview:getDefenderForStorage', __args__, opts=opts, typ=GetDefenderForStorageResult).value

    return AwaitableGetDefenderForStorageResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        properties=pulumi.get(__ret__, 'properties'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_defender_for_storage)
def get_defender_for_storage_output(resource_id: Optional[pulumi.Input[str]] = None,
                                    setting_name: Optional[pulumi.Input[str]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDefenderForStorageResult]:
    """
    Gets the Defender for Storage settings for the specified storage account.


    :param str resource_id: The identifier of the resource.
    :param str setting_name: Defender for Storage setting name.
    """
    ...
